dune-init(1)

NAME

dune-init - Initialize dune components

SYNOPSIS

dune init [OPTION]... INIT_KIND NAME [PATH]

DESCRIPTION

dune init {library,executable,test,project} NAME [PATH] initialize a new dune component of the specified kind, named NAME, with fields determined by the supplied options.

Any prefix of the component kinds can be supplied, e.g., dune init proj myproject.

If the optional PATH is provided, the component will be created there. Otherwise, it is created in the current working directory.

The command can be used to add stanzas to existing dune files as well as for creating new dune files and basic component templates.

OPTIONS

--build-info
    Show build information.

-f, --force
    Force actions associated to aliases to be re-executed even if their dependencies haven't changed.

--help[=FMT] (default=auto)
    Show this help in format FMT. The value FMT must be one of `auto', `pager', `groff' or `plain'. With `auto', the format is `pager` or `plain' whenever the TERM env var is `dumb' or undefined.

--inline-tests
    Whether to use inline tests. Only applicable for library and project components.

--kind=PROJECT_KIND
    The kind of project to initialize. Valid options are e[xecutable] or l[ibrary]. Defaults to executable. Only applicable for project components.

--libs=LIBRARIES
    A comma separated list of libraries on which the component depends

--pkg=PACKAGE_MANAGER
    Which package manager to use. Valid options are o[pam] or e[sy]. Defaults to opam. Only applicable for project components.

--ppx=PREPROCESSORS
    A comma separated list of ppx preprocessors used by the component

--public[=PUBLIC_NAME] (default=<default>)
    If called with an argument, make the component public under the given PUBLIC_NAME. If supplied without an argument, use NAME.

--sandbox=VAL (absent DUNE_SANDBOX env)
    Sandboxing mode to use by default. Some actions require a certain sandboxing mode, so they will ignore this setting. The allowed values are: none, symlink, copy.

--version
    Show version information.

-w, --watch
    Instead of terminating build after completion, wait continuously for file changes.

COMMON OPTIONS

--always-show-command-line
    Always show the full command lines of programs executed by dune

--auto-promote
    Automatically promote files. This is similar to running dune promote after the build.

--build-dir=FILE (absent DUNE_BUILD_DIR env)
    Specified build directory. _build if unspecified

--cache=VAL (absent DUNE_CACHE env)
    Activate binary cache (either `disabled' or `enabled'). Default is `disabled'.

--cache-check-probability=VAL (absent=0. or DUNE_CACHE_CHECK_PROBABILITY env)
    Probability cached rules are rerun to check for reproducibility

--cache-duplication=VAL (absent DUNE_CACHE_DUPLICATION env)
    Binary cache duplication mode

--cache-transport=VAL (absent DUNE_CACHE_TRANSPORT env)
    Binary cache protocol

--config-file=FILE
    Load this configuration file instead of the default one.

--debug-artifact-substitution
    Print debugging info about artifact substitution

--debug-backtraces
    Always print exception backtraces.

--debug-dependency-path
    In case of error, print the dependency path from the targets on the command line to the rule that failed.

--debug-findlib
    Debug the findlib sub-system.

--default-target=TARGET (absent=@@default)
    Set the default target that when none is specified to dune build.

--diff-command=VAL
    Shell command to use to diff files. Use - to disable printing the diff.

--disable-promotion (absent DUNE_DISABLE_PROMOTION env)
    Disable all promotion rules

--display=MODE
    Control the display mode of Dune. See dune-config(5) for more details.

--ignore-promoted-rules
    Ignore rules with (mode promote), except ones with (only ...). The variable %{ignoring_promoted_rules} in dune files reflects whether this option was passed or not.

--instrument-with=BACKENDS (absent DUNE_INSTRUMENT_WITH env)
    "Enable instrumentation by BACKENDS. BACKENDS is a comma-separated list of library names, each one of which must declare an instrumentation backend.

-j JOBS
    Run no more than JOBS commands simultaneously.

--no-buffer
    Do not buffer the output of commands executed by dune. By default dune buffers the output of subcommands, in order to prevent interleaving when multiple commands are executed in parallel. However, this can be an issue when debugging long running tests. With --no-buffer, commands have direct access to the terminal. Note that as a result their output won't be captured in the log file. You should use this option in conjunction with -j 1, to avoid interleaving. Additionally you should use --verbose as well, to make sure that commands are printed before they are being executed.

--no-config
    Do not load the configuration file

--no-print-directory
    Suppress "Entering directory" messages

--only-packages=PACKAGES
    Ignore stanzas referring to a package that is not in PACKAGES. PACKAGES is a comma-separated list of package names. Note that this has the same effect as deleting the relevant stanzas from dune files. It is mostly meant for releases. During development, it is likely that what you want instead is to build a particular <package>.install target.

-p PACKAGES, --for-release-of-packages=PACKAGES
    Shorthand for --release --only-packages PACKAGE. You must use this option in your <package>.opam files, in order to build only what's necessary when your project contains multiple packages as well as getting reproducible builds.

--profile=VAL (absent DUNE_PROFILE env)
    Select the build profile, for instance dev or release. The default is dev.

--promote-install-files
    Promote the generated <package>.install files to the source tree

--release
    Put dune into a reproducible release mode. This is in fact a shorthand for --root . --ignore-promoted-rules --no-config --profile release --always-show-command-line --promote-install-files --default-target @install. You should use this option for release builds. For instance, you must use this option in your <package>.opam files. Except if you already use -p, as -p implies this option.

--root=DIR
    Use this directory as workspace root instead of guessing it. Note that this option doesn't change the interpretation of targets given on the command line. It is only intended for scripts.

--store-orig-source-dir (absent DUNE_STORE_ORIG_SOURCE_DIR env)
    Store original source location in dune-package metadata

--terminal-persistence=MODE
     Changes how the log of build results are displayed to the console between rebuilds while in --watch mode.

--trace-file=FILE
    Output trace data in catapult format (compatible with chrome://tracing)

--verbose
    Same as --display verbose

--workspace=FILE (absent DUNE_WORKSPACE env)
    Use this specific workspace file instead of looking it up.

-x VAL
    Cross-compile using this toolchain.

ENVIRONMENT

These environment variables affect the execution of init:

DUNE_BUILD_DIR
    Specified build directory. _build if unspecified

DUNE_CACHE
    Activate binary cache (either `disabled' or `enabled'). Default is `disabled'.

DUNE_CACHE_CHECK_PROBABILITY
    Probability cached rules are rerun to check for reproducibility

DUNE_CACHE_DUPLICATION
    Binary cache duplication mode

DUNE_CACHE_TRANSPORT
    Binary cache protocol

DUNE_DISABLE_PROMOTION
    Disable all promotion rules

DUNE_INSTRUMENT_WITH
    "Enable instrumentation by BACKENDS. BACKENDS is a comma-separated list of library names, each one of which must declare an instrumentation backend.

DUNE_PROFILE
    Build profile. dev if unspecified or release if -p is set.

DUNE_SANDBOX
    Sandboxing mode to use by default. (see --sandbox)

DUNE_STORE_ORIG_SOURCE_DIR
    Store original source location in dune-package metadata

DUNE_WORKSPACE
    Use this specific workspace file instead of looking it up.

EXAMPLES

1.  Define an executable component named `myexe' in a dune file in the current directory:

      dune init exe myexe

2.  Define a library component named `mylib' in a dune file in the ./src directory depending on the core and cmdliner libraries, the ppx_let and ppx_inline_test preprocessors, and declared as using inline tests":

      dune init lib mylib src --libs core,cmdliner --ppx ppx_let,ppx_inline_test --inline-tests"

3.  Define a library component named `mytest' in a dune file in the ./test directory that depends on `mylib'":

      dune init test myexe test --libs mylib